    .section "vectors"
    .global  reset

    b       reset   ;@ 0x00000000 reset
undef:  b   undef   ;@ 0x00000004 undefined instruction
    b       _swi    ;@ 0x00000008 software interrupt swi
pabt:   b   pabt    ;@ 0x0000000C prefetch abort
dabt:   b   dabt    ;@ 0x00000010 data abort
    nop             ;@ 0x00000014 undefined
irq:    b   irq     ;@ 0x00000018 irq
fiq:    b   fiq     ;@ 0x0000001C fiq

    .text
reset:
    @@ Copy data to RAM.
    ldr r0, =flash_sdata
    ldr r1, =ram_sdata
    ldr r2, =data_size
    
    @@ Handle data_size == 0
    cmp r2, #0
    beq init_bss

copy:
    ldrb    r4, [r0], #1
    strb    r4, [r1], #1
    subs    r2, r2, #1
    bne copy

init_bss:
    @@ Initialize .bss
    ldr r0, =sbss
    ldr r1, =ebss
    ldr r2, =bss_size

    @@ Handle bss_size == 0
    cmp r2, #0
    beq init_stack

    mov r4, #0

zero:
    strb    r4, [r0], #1
    subs    r2, r2, #1
    bne zero

init_stack:
    @@ Initialize stack pointer
    ldr sp, =0xA4000000

    bl  main
    
    @@ Loop indefinitely on return from main
stop:   b   stop
