.globl  _start
_start:
    b       reset       ;@ 0x00000000 reset
    b       undef_inst  ;@ 0x00000004 undefined instruction
    b       supervisor  ;@ 0x00000008 software interrupt swi
    b       handler     ;@ 0x0000000C prefetch abort
    b       handler     ;@ 0x00000010 data abort
    b       handler     ;@ 0x00000014 undefined
    b       irq         ;@ 0x00000018 irq
    b       fiq         ;@ 0x0000001C fiq

handler:
    b       handler

undef_inst:
    b       undef_inst

irq:
    b   irq

fiq:
    b   fiq

supervisor:
    stmfd   sp!, {r0-r12,lr}
    ldr     r0, [lr,#-4]
    bic     r0, r0, #0xff000000

    ldmfd   sp!, {r0-r12,pc}^

reset:
    mov     r0, #5
    mov     r1, #4
    swi     0x0
    add     r2, r1, r0

stop:
    b       stop
